import remarkParse from 'remark-parse';
import { toString } from 'mdast-util-to-string';
import { unified } from 'unified';
import { selectAll } from 'unist-util-select';
import frontmatter from 'remark-frontmatter';
import GithubSlugger from 'github-slugger';

const _extract_toc = (tree) => {
    // Using a selector to extract heading texts
    const toc = selectAll("heading", tree).map((n) => {
        var slugger = new GithubSlugger();
        const text = toString(n);
        return { depth: n.depth, text, id: slugger.slug(text) };
    });
    return toc;
};
const extract_toc = async (content) => {
    const processor = unified().use(remarkParse).use(frontmatter);
    const mdast_tree = processor.parse(content);
    const toc = _extract_toc(mdast_tree);
    return toc;
};

export { extract_toc };
