import { Type } from '@sinclair/typebox';

var Lang;
(function (Lang) {
    Lang["es"] = "es";
    Lang["en"] = "en";
})(Lang || (Lang = {}));
const Frontmatter = Type.Object({
    title: Type.String({ description: "Content Title" }),
    title_short: Type.Optional(Type.String({ description: "Content Title", maxLength: 150 })),
    subtitle: Type.Optional(Type.String({
        description: "Short description",
        maxLength: 200,
    })),
    lang: Type.Optional(Type.Enum(Lang, { description: "Content language" })),
    categories: Type.Optional(Type.Array(Type.String(), {
        description: "A list of topics for this content",
    })),
    authors: Type.Optional(Type.Array(Type.String(), {
        description: "List of urls pointing to og:profile contents",
    })),
    modeldata: Type.Record(Type.String(), Type.Any(), {
        description: "An object of data passed to frontend render",
        additionalProperties: true,
    }),
}, {
    $id: "Frontmatter",
    description: "MD or MDX content must adhere to this spec to be built",
    additionalProperties: false,
});

export { Frontmatter, Lang };
